<?php
defined('_JEXEC') or die;

class PlgSystemJshopping_social_login extends JPlugin{
	
	public function onAfterInitialise() {
		//check social login 
		$socialNetwork = \JFactory::getApplication()->input->getCmd('jshopping_social_login');	
		if (empty($socialNetwork)) {
			$state = json_decode(base64_decode(strtr(\JFactory::getApplication()->input->get('state') ?? "", '-_,', '+/=')));
			if (isset($state->jshopping_social_login) and !empty($state->jshopping_social_login)) {
				$socialNetwork = $state->jshopping_social_login;
			}
		}
		if (!$socialNetwork) {
			return 0;
		}
		
		require_once(JPATH_SITE.'/components/com_jshopping/bootstrap.php');
		require_once(dirname(__FILE__).'/helper.php');
		\JFactory::getDocument()->addScript(\JURI::root()."components/com_jshopping/js/addons/jshopping_social_login/script.js", "text/javascript");		
		
		\JSFactory::loadExtLanguageFile('jshopping_social_login');
		\JPluginHelper::importPlugin('jshoppingcheckout');
		$dispatcher = \JFactory::getApplication();
	
		$session = \JFactory::getSession();
		$db = \JFactory::getDBO();		
		$type = jshopping_social_login_helper::get_type();
		
		$info_user = jshopping_social_login_helper::checkSocialNetwork($socialNetwork);
		$dispatcher->triggerEvent('addonSociaLoginInfoUser', array(&$info_user, &$socialNetwork));

		if ($info_user->id > 0 && $type == 'login') {
			// Remove the session if any.
			if ($session->get('tmpuser')) {
				$session->clear('tmpuser');
			}
			
			$user_data = (array)$info_user;
			
			if (!empty($user_data['f_name'])){
				$user_data['f_name'] = jshopping_social_login_helper::get_filter_username($user_data);
			}
			
			if (!empty($user_data['l_name'])){
				$user_data['l_name'] = jshopping_social_login_helper::get_filter_user_l_name($user_data);
			}
			
			// find id social network
			$user_id = jshopping_social_login_helper::get_find_social_network_id($user_data);
			
			// return data to user
			if (!$user_data['email']) $user_data['email'] = jshopping_social_login_helper::get_random_email($user_data);
			if (!$user_id) $user_id = jshopping_social_login_helper::get_find_social_network_email($user_data);
			
			if ($user_id > 0){
				$block_id = jshopping_social_login_helper::get_find_not_activate($user_id);
				
				if (!empty($block_id) || $block_id) {
					\JSError::raiseWarning ('', _JSHOP_SOCIAL_LOGIN_ERROR_USER_NOTACTIVATE);
					\JSHelper::saveToLog("social_login.log", _JSHOP_SOCIAL_LOGIN_ERROR_USER_NOTACTIVATE);
					return false;
				}
				
				$block_id = jshopping_social_login_helper::get_find_user_block($user_id);
				
				if (!empty($block_id) || $block_id) {
					\JSError::raiseWarning ('', _JSHOP_SOCIAL_LOGIN_ERROR_USER_BLOCK);
					\JSHelper::saveToLog("social_login.log", _JSHOP_SOCIAL_LOGIN_ERROR_USER_BLOCK);
					return false;
				}
			} else {
				//create user
				$user = new JUser;
				
				// If user registration is not allowed, show 403 not authorized.
				$usersConfig = JComponentHelper::getParams( 'com_users' );
				
				if ($usersConfig->get('allowUserRegistration') == '0') {
					\JSError::raiseWarning('', _JSHOP_SOCIAL_LOGIN_ERROR_REGISTER_DISABLED);
					\JSHelper::saveToLog("social_login.log", _JSHOP_SOCIAL_LOGIN_ERROR_REGISTER_DISABLED);
					return false;
				}
				
				// Default to Registered.
				$defaultUserGroup = $usersConfig->get('new_usertype');
				
				if (empty($defaultUserGroups)) {
					$defaultUserGroups = 'Registered';
				}
				
				// if username already exists
				$_f_name = \JApplicationHelper::stringURLSafe($user_data['f_name']);
				$_l_name = \JApplicationHelper::stringURLSafe($user_data['l_name']);
				$username = $_f_name.'_'.$_l_name;
				$username = $_f_name.$_l_name != '' ? $username : 'user_'.$socialNetwork.'_'.$user_data['id'];
				$username = jshopping_social_login_helper::get_exist_username($username);
				// Remove special char if have.
				$username = jshopping_social_login_helper::remove_unescapedChar($username);					
				$name = jshopping_social_login_helper::remove_unescapedChar($user_data['f_name'].' '.$user_data['l_name']);
				if ($name==""){
					$name = $username;
				}
				//Insert data 
				jimport ('joomla.user.helper');
				
				$userdata = array ();
				$userdata ['name'] = $name;
				$userdata ['username'] = $username;
				if(!$userdata ['username']) $userdata ['username']=$userdata ['name'];
				$userdata ['email'] = $user_data['email'];
				$userdata ['usertype'] = 'deprecated';
				
				$userdata ['groups'] = array($defaultUserGroup);
				$userdata ['registerDate'] = date('Y-m-d H:i:s');
				$userdata ['password'] = JUserHelper::genRandomPassword();
				$userdata ['password2'] = $userdata ['password'];
				$user->set('block', '0');
				$user->set('activation', '');

				if (!$user->bind ($userdata)) {
					\JSError::raiseWarning('', \JText::_ ('COM_USERS_REGISTRATION_BIND_FAILED'));
					\JSHelper::saveToLog("social_login.log", "error user bind ".print_r($userdata, 1));
					return false;
				}
				if (!$user->save()) {
					\JSError::raiseWarning('', _JSHOP_SOCIAL_LOGIN_ERROR_REGISTER_FAILED);
					\JSHelper::saveToLog("social_login.log", "error user save ".print_r($userdata, 1));
					return false;
				}
				
				$user_id = $user->get('id');
				\JSHelper::saveToLog("social_login.log", "new user save ".print_r($userdata, 1));
			}
		} else {
			$user_id = 0;
			\JSHelper::saveToLog("social_login.log", "social user_id 0");
		}
		
		if ($user_id > 0) {
			if (jshopping_social_login_helper::save_userprofile_data($user_id, $user_data)){
				jshopping_social_login_helper::update_userprofile_data($user_id, $user_data);
			}			
			$user = jshopping_social_login_helper::user_logIn($user_id);
			$session->clear('tmpuser');
		}
		
		?>
		<html>		
		<body>
		<script type="text/javaScript" src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
		<script type="text/javaScript" src="<?php print JURI::root()?>/components/com_jshopping/js/addons/jshopping_social_login/script.js"></script>
		<script type="text/javaScript">
			if (window.opener){
				window.opener.window_restart();
				window.close();
			} else {
				document.location.href="<?php print JURI::root()?>";
			}
		</script>
		</body>
		</html>
		
		<?php
		die;		
	}
}